
typedef struct {
    String reason;
} ExitCode;

ExitCode ecode_new(char* ptr){
    return (ExitCode) {
        .reason = from_c_str(ptr),
    };
}

// Not thread safe
// Luckily ableOS will not support OSThreads
typedef struct {
    u16 count;
    ExitCode exit_codes[];
} ExitCodeArray;


typedef struct {
    ExitCodeArray exit_code_registry;
} ExitCodeRegistry;



ExitCodeRegistry exit_codes;


// Register an exit code in ableOS
// Returns:
// -    A non-zero u8: When the exit code is registered
// -    Zero: something has gone horrible
u16 register_exit_code(ExitCode ecode) {
    exit_codes.exit_code_registry.exit_codes[exit_codes.exit_code_registry.count] = ecode;
    exit_codes.exit_code_registry.count += 1;
    return exit_codes.exit_code_registry.count - 1;
}
