

typedef enum {
    ProcessSuccess,
    NoPermission,
    NoProcess,

    AlreadyRunning,
} ProcessResponse;

ProcessID new_id(u64 host, u64 local) {
    return (ProcessID) {
        .host = host,
        .local = local
    };
}
// Kill a process
ProcessResponse terminate_process(ProcessID pid) {
    return NoPermission;
}

// Request the kernel to create a new empty process
// A process is not started as soon as it is created
// This gives the starting process time to set it up
ProcessID create_process() {
    trace("New process created");
    return new_id(0, 0);
}

// Start execution of a created process
ProcessResponse start_process(ProcessID pid) {
    trace("Process started.");

    return AlreadyRunning;
}
