// Log Levels
typedef enum {
    ERROR = 0,
    WARN = 1,
    INFO = 2,
    DEBUG = 3,
    TRACE = 4,
} Level;

// An inner log function
// Call into the IPC log service from here
void inner_log(Level level, const char* message, const char* file, int line) {
    const char* lvl_str = "";
    switch (level) {
        case ERROR:
            lvl_str = "ERROR";
            break;
        case WARN:
            lvl_str = "WARN ";
            break;
        case INFO:
            lvl_str = "INFO ";
            break;
        case DEBUG:
            lvl_str = "DEBUG";
            break;
        case TRACE:
            lvl_str = "TRACE";
            break;
    }
    BufferID log_buffer = construct_buffer_id(0, 1);
    ipc_send(log_buffer, message, c_str_len(message));

    printf("%s [%s:%d]: %s\r\n", lvl_str, file, line, message);
}
