// A small collection of functions related to the ableOS String type as defined in the header file string.h
// Notes:
// - All functions in the library must operate on unicode only.


// Check the length of a default c string 
// Returns a u32
inline static u32 c_str_len(char const* ptr) {
    if (ptr == NULL) {
        return 0;
    }
    u32 len = 0;
    while (*ptr != '\0') {
        ++ptr;
        ++len;
    }
    return len;
}

String from_c_str(char* ptr) {
    return (String) {
        .ptr = ptr,
        .len = c_str_len(ptr)
    };
}


// String equality tests for length/contents
// If the contents and length are the same then it is true else its false 
bool string_eq(String lhs, String rhs) {
    bool same_contents = false;
    bool same_ptr = false;
    bool same_len = false;

    if (lhs.ptr == rhs.ptr) {
        same_ptr = true;   
    }

    if (lhs.len == rhs.len) {
        same_len = true;
    }
    if (same_len && same_ptr){
        return true;
    } else {
        // TODO: still check the contents instead of just unconditionally falsing
        return false;
    }
}