// All System Resource IDs are declared here
// as well as compound IDs


// The Host Node ID of a Resource in an ableOS Cluster
#define HostID u64

// The Localized Resource ID in an ableOS Cluster
#define LocalID u64

typedef struct {
    // The Host Node ID of a Process in an ableOS Cluster
    HostID host;
    // The Local Node ID of a Process in an ableOS Cluster
    LocalID local;
} ProcessID;

typedef struct {
    // The Host Node ID of a Buffer in an ableOS Cluster
    HostID host_id;
    // The Local Node ID of a Buffer in an ableOS Cluster
    LocalID local_id;
} BufferID;


BufferID construct_buffer_id(HostID host_id, LocalID local_id){
       return (BufferID) {
        .host_id = host_id,
        .local_id = local_id
    };
}


